﻿using Dto;
using Entities;
using Model.OrderCriteria;
using Shared;
using Shared.Mapper;

namespace API.Service;

public class SuccessDataServiceApi(ISuccessService<SuccessEntity> sucessService) : ISuccessService<SuccessDTO>
{
    public IEnumerable<SuccessDTO> GetSuccesses(int page, int number, SuccessOrderCriteria orderCriteria)
    {
        var successesEntities = sucessService.GetSuccesses(page, number, orderCriteria);
        return successesEntities.Select(e => e.FromEntityToDTO()).ToList();
    }

    public IEnumerable<SuccessDTO> GetSuccessesByUserId(int id) => sucessService.GetSuccessesByUserId(id).Select(s => s.FromEntityToDTO());

    public IEnumerable<SuccessDTO> GetSuccessesByInquiryId(int id) => sucessService.GetSuccessesByInquiryId(id).Select(s => s.FromEntityToDTO());

    public bool DeleteSuccess(int idUser, int idInquiry) => sucessService.DeleteSuccess(idUser, idInquiry);

    public SuccessDTO UpdateSuccess(int idUser, int idInquiry, SuccessDTO success) =>
        sucessService.UpdateSuccess(idUser, idInquiry, success.FromDTOToEntity()).FromEntityToDTO();

    public SuccessDTO CreateSuccess(int userId, int inquiryId, bool isFinished) =>
        sucessService.CreateSuccess(userId, inquiryId, isFinished).FromEntityToDTO();
}